SystemOrganization addCategory: #ConfigurationOfCasper!

Object subclass: #ConfigurationOfCasper
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfCasper'!

!ConfigurationOfCasper class methodsFor: 'development support' stamp: 'MiguelCampusano 8/9/2012 03:01'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfCasper class methodsFor: 'private' stamp: 'MiguelCampusano 8/9/2012 03:01'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfCasper class methodsFor: 'private' stamp: 'MiguelCampusano 8/9/2012 03:01'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfCasper class methodsFor: 'private' stamp: 'MiguelCampusano 8/9/2012 03:01'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfCasper class methodsFor: 'metacello tool support' stamp: 'MiguelCampusano 8/9/2012 03:01'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfCasper class methodsFor: 'loading' stamp: 'MiguelCampusano 8/9/2012 03:01'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfCasper class methodsFor: 'loading' stamp: 'MiguelCampusano 8/9/2012 03:01'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfCasper class methodsFor: 'loading' stamp: 'MiguelCampusano 8/9/2012 03:01'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfCasper class methodsFor: 'accessing' stamp: 'MiguelCampusano 8/9/2012 03:01'!
project

	^self new project! !

!ConfigurationOfCasper class methodsFor: 'development support' stamp: 'MiguelCampusano 8/9/2012 03:01'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfCasper methodsFor: 'baselines' stamp: 'MiguelCampusano 8/10/2012 16:03'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/Casper'.
		spec package: 'Casper-Core'.
		spec package: 'Phantom-Tests' with: [ spec repository: 'http://www.squeaksource.com/Phantom'; requires: #('Casper-Core')].
		
		spec group: 'Tests' with: #('Phantom-Tests').
		spec group: 'Core' with: #('Casper-Core').
		spec group: 'default' with: #('Casper-Core' ). ].

! !

!ConfigurationOfCasper methodsFor: 'symbolic versions' stamp: 'MiguelCampusano 8/9/2012 03:01'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfCasper methodsFor: 'accessing' stamp: 'MiguelCampusano 8/9/2012 03:01'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfCasper methodsFor: 'versions' stamp: 'MiguelCampusano 8/10/2012 16:03'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'MiguelCampusano'.
		spec timestamp: '8/9/2012 03:01'.
		spec package: 'Casper-Core' with: 'Casper-Core-MiguelCampusano.2'. 
		spec package: 'Phantom-Tests' with: 'Phantom-Tests-dgg.22'].
	
! !
